ljDates = new Object();
ljDelete = new Object();
LiveJournal = window.arguments[0];
ljPost = window.arguments[1];

function Init() {
	// Initial function, sets up calendar.
	// In: Nothing.
	// Out: Nothing.
	document.getElementById("progressbar").mode = "undetermined";	
	dsCalendar.extraSetSelected = function(day, month, year) {
		var eventlist = document.getElementById("entrieslist");
		while (eventlist.childNodes.length > 2) {
			eventlist.removeChild(eventlist.lastChild);
		}
		eventlist.appendChild(document.createElement("listitem"));
		eventlist.lastChild.setAttribute("label", "Loading...");
		document.getElementById("progressdeck").selectedIndex = 0;
		ljEvents.getEventsChallenge();
	}
	
	dsCalendar.extraChangeYear = function(curobj) {
		curobj.setAttribute("oncommand", curobj.getAttribute("oncommand") + " ljDates.makeBoldDays(dsCalendar.year, parseInt(dsCalendar.month + 1, 10), ljDates.dates);");
	}
	
	var cal = new Date();
	dsCalendar.init(cal);
	dsCalendar.setSelected(document.getElementById("day" + dsCalendar.selectedday));
	var mpop = document.getElementById("monthspopup");
	for (i = 0; i < mpop.childNodes.length; i++) {
		mpop.childNodes[i].setAttribute("oncommand", mpop.childNodes[i].getAttribute("oncommand") + " ljDates.makeBoldDays(dsCalendar.year, parseInt(dsCalendar.month + 1, 10), ljDates.dates);");
	}
	var monthless = document.getElementById("monthless");
	var monthmore = document.getElementById("monthmore");
	monthless.setAttribute("oncommand", monthless.getAttribute("oncommand") + " ljDates.makeBoldDays(dsCalendar.year, parseInt(dsCalendar.month + 1, 10), ljDates.dates);");
	monthmore.setAttribute("oncommand", monthmore.getAttribute("oncommand") + " ljDates.makeBoldDays(dsCalendar.year, parseInt(dsCalendar.month + 1, 10), ljDates.dates);");
	ljDates.getDatesChallenge();
}

ljDates.getDatesChallenge = function() {
	// Sends a request for a challenge to the server, then starts loading the dates when it gets one (to make them bold).
	// In: Nothing.
	// Out: Nothing.
	this.httpreq = new XMLHttpRequest()
	this.httpreq.onload = this.challengeHandler.onResult;
	this.httpreq.onerror = this.challengeHandler.onError;
	this.httpreq.open("POST", LiveJournal.posturl, true);
	this.httpreq.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	this.httpreq.send("mode=getchallenge");
}

ljDates.challengeHandler = {
	// This gets hit as the response from the server when asked for a challenge. The code should be pretty self-explanatory.
	onResult: function() {
		if (LiveJournal.getResponseData("success", ljDates.httpreq.responseText) == "OK") {
			var challenge = LiveJournal.getResponseData("challenge", ljDates.httpreq.responseText);
			ljDates.getDates(challenge);
		} else {
			alert("There was an error with the request: " + LiveJournal.getResponseData("errmsg", ljDates.httpreq.responseText));
		}
	},
	onError: function () {
		alert("There was an error connecting to the server.");
	}
}

ljDates.getDates = function(challengestring) {
	// Sends a call to the server to get a list of the days that have posts on them.
	// In: The challenge issued by the server.
	// Out: Nothing.
	this.httpreq = new XMLHttpRequest();
	this.httpreq.onload = this.datesHandler.onResult;
	this.httpreq.onerror = this.datesHandler.onError;
	this.httpreq.open("POST", LiveJournal.posturl, true);
	this.httpreq.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	var params = new Object();

	params.user = LiveJournal.username;
	params.auth_method = "challenge";
	params.auth_challenge = challengestring;
	params.auth_response = hexMD5(challengestring + hexMD5(LiveJournal.password));
	params.ver = 1;
	if (LiveJournal.username != ljPost.usejournal) {
		params.usejournal = ljPost.usejournal;
	}
	
	var body = "mode=getdaycounts";
	body += LiveJournal.makeParams(params);

	this.httpreq.send(body);
}

ljDates.datesHandler = {
	// This gets hit as the response from the server when asked for a challenge. The code should be pretty self-explanatory.
	onResult: function() {
		if (LiveJournal.getResponseData("success", ljDates.httpreq.responseText) == "OK") {
			ljDates.dates = ljDates.httpreq.responseText;
			var now = new Date();
			ljDates.makeBoldDays(now.getFullYear(), now.getMonth() + 1, ljDates.dates);
		} else {
			alert("There was an error with the request: " + LiveJournal.getResponseData("errmsg", ljDates.httpreq.responseText));
		}
	},
	onError: function () {
		alert("There was an error connecting to the server.");
	}
}

ljDates.makeBoldDays = function(year, month) {
	// Makes the days with posts bolded.
	// In: The year to look up, the month to look up. Each day in the month is checked.
	// Out: Nothing.
	var days = document.getElementById("calendarbox").getElementsByTagName("toolbarbutton");
	for (i = 0; i < days.length; i++) {
		var dateid = days[i].getAttribute("id");
		var curday = dateid.match(/[^day]/gi).join("");
		var datestring = year + "-" + ZeroFix(month) + "-" + ZeroFix(curday);
		var postcount = parseInt(LiveJournal.getResponseData(datestring, this.dates), 10);
		if (postcount > 0) {
			days[i].setAttribute("style", "font-weight: bold");
			days[i].setAttribute("tooltiptext", postcount + " posts on this day");
		}
	}
	window.sizeToContent();
}

function ZeroFix(TheNumber) {
	// To pad out numbers so they're always 2 digits long.
	// In: A number less than or equal to 10.
	// Out: The number, with a zero added at the front if it is 9 or less. 
	if (TheNumber < 10) { TheNumber = "0" + TheNumber; }
	return TheNumber;
}

function FixClock(time) {
	// This formats LiveJournal's crazy date format into something nice looking.
	// In: Crazily formatted LJ date string.
	// Out: 12-hour time string with "am" or "pm".
	var clockarray = time.split(":");
	var hour = clockarray[0];
	var minute = clockarray[1];
	var ampm = " am";
	hour = parseInt(hour.slice(hour.lastIndexOf(" ")),10);
	if (hour > 11) {
		ampm = " pm";
		hour = hour - 12;
	}
	if (hour == 0) {
		hour = 12;
	}
	return hour + ":" + minute + ampm;
}

function ViewPost(postnode) {
	// Opens the browser to the currently selected post in the history window.
	// In: The XUL node of the selected post.
	// Out: Nothing.
	if (postnode) {
		var domain = FindDomain(LiveJournal.posturl);
		var postsplit = postnode.value.split("|");
		var itemid = postsplit[0];
		var anum = postsplit[1];
		var username;
		if (LiveJournal.username != ljPost.usejournal) {
			username = ljPost.usejournal;
		} else {
			username = LiveJournal.username;
		}
		var urlstring = domain + "users/" + username + "/" + ((parseInt(itemid, 10) * 256) + parseInt(anum, 10)) + ".html";
		dsOpenTopWin(urlstring);
	}
}


function EditPost(postnode) {
	// Loads an edit window for the selected post.
	// In: Node of the selected post.
	// Out: Nothing.
	if (postnode) {
		var itemid = parseInt(postnode.value.split("|")[0], 10);
		var windowid = "dsedit" + itemid;
		var windowwatcher = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
		var editwindow = windowwatcher.getWindowByName(windowid, null);
		if (editwindow) {
			editwindow.focus();
		} else {
			window.openDialog("livejournal.xul",windowid,"chrome,resizable,titlebar,dialog=no", LiveJournal, itemid, ljPost.usejournal);
		}
	}
}

function DeletePost(postnode) {
	// Deletes the selected post.
	// In: Node of the selected post.
	// Nothing.
	if (postnode) {
		if (confirm("Are you sure you want to delete this post?")) {
			document.getElementById("progressdeck").selectedIndex = 0;
			ljDelete.itemid = postnode.value.split("|")[0];
			ljDelete.getChallenge();
		}
	}
}

ljDelete.getChallenge = function() {
	// Gets challenge for deleting post.
	// In: Nothing.
	// Out: Nothing.
	this.httpreq = new XMLHttpRequest()
	this.posturl = LiveJournal.posturl;
	this.httpreq.onload = this.challengeHandler.onResult;
	this.httpreq.onerror = this.challengeHandler.onError;
	this.httpreq.open("POST", this.posturl, true);
	this.httpreq.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	this.httpreq.send("mode=getchallenge");
}

ljDelete.challengeHandler = {
	// This gets hit as the response from the server when asked for a challenge. The code should be pretty self-explanatory.
	onResult: function() {
		if (LiveJournal.getResponseData("success", ljDelete.httpreq.responseText) == "OK") {
			var challenge = LiveJournal.getResponseData("challenge", ljDelete.httpreq.responseText);
			ljDelete.deletePost(challenge);
		} else {
			alert("There was an error with the request: " + LiveJournal.getResponseData("errmsg", ljDelete.httpreq.responseText));
		}
	},
	onError: function () {
		alert("There was an error connecting to the server.");
	}
}

ljDelete.deletePost = function(challengestring) {
	// Sends request to delete post.
	// In: Challenge string issued from the server.
	// Out: Nothing.
	this.httpreq = new XMLHttpRequest();
	this.httpreq.onload = this.deletionHandler.onResult;
	this.httpreq.onerror = this.deletionHandler.onError;
	this.httpreq.open("POST", LiveJournal.posturl, true);
	this.httpreq.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	var params = new Object();
	
	params.user = LiveJournal.username;
	params.auth_method = "challenge";
	params.auth_challenge = challengestring;
	params.auth_response = hexMD5(challengestring + hexMD5(LiveJournal.password));
	params.ver = 1;
	if (LiveJournal.username != ljPost.usejournal) {
		params.usejournal = ljPost.usejournal;
	}

	params.subject = "";
	params.lineendings = "unix";
	params.event = "";
	params.year = 1;
	params.month = 1;
	params.day = 1;
	params.hour = 1;
	params.minute = 1;
	params.itemid = this.itemid;

	var body = "mode=editevent";
	body += LiveJournal.makeParams(params);
	
	this.httpreq.send(body);
}

ljDelete.deletionHandler = {
	// This gets hit as the response from the server when asked for a challenge. The code should be pretty self-explanatory.
	onResult: function() {
		if (LiveJournal.getResponseData("success", ljDelete.httpreq.responseText) == "OK") {
			document.getElementById("progressdeck").selectedIndex = 1;
			dsCalendar.setSelected();
		} else {
			alert("There was an error with the request: " + LiveJournal.getResponseData("errmsg", ljDelete.httpreq.responseText));
		}
	},
	onError: function () {
		alert("There was an error connecting to the server.");
	}
}
